<?xml version="1.0" encoding="UTF-8"?>
<con:xqueryEntry xmlns:con="http://www.bea.com/wli/sb/resources/config">
  <con:description>insertUserAndRolesInSearchQuery</con:description>
  <con:xquery>(: name spaces :)
declare namespace aci= "http://schemas.autonomy.com/aci/";
declare namespace ctx= "http://www.bea.com/wli/sb/context";
declare namespace user = "http://dk/skat/ip/autonomy/wli/processes/userroles";
declare namespace role = "http://www.skat.dk/2008/05/06/RoleListReplySchema";

(: a variable recording the original version of the fieldtext part of the query :)
declare variable $originalFieldText as xs:string? external;

(: a variable holding information about the user's roles :)
declare variable $roleResponse as element()* external;

(: defines a fieldtext restriction based on a user name :)
declare function local:user-restriction($username as xs:string) as xs:string {
  concat("U:*", $username, "* G:*")
};

(: defines a fieldtext restriction based on a group name :)
declare function local:group-restriction($groupname as xs:string) as xs:string {
  concat("U:* G:*",  $groupname, "*")
};

(: defines group restrictions based on a list of groups :)
declare function local:group-restrictions($list as element()*)  as xs:string {
     fn:string-join(for $element in $list return local:group-restriction($element),",")
};

(: parenthesize phrase :)
declare function local:parenthesize($phrase as xs:string) as xs:string {
   if ($phrase and $phrase!="") then  concat("(",$phrase,")") else ""
};

(: combine two fieldtext phrases :)
declare function local:combine($combiner as xs:string, $left as xs:string, $right as xs:string) as xs:string {
 if (($left!="") and ($right!="")) then concat($left,$combiner,$right) else concat($left,$right)
};

(: transform null to empty string :)
declare function local:null-to-empty($input as xs:string?) as xs:string {
 if ($input) then $input else ""
};

(: end field restriction :)
declare function local:endfield($fieldtext as xs:string) as xs:string {
 concat("(WILD{",$fieldtext,"}:SKAT_ACL)")
};

&lt;aci:fieldtext>
{ 
local:combine("+AND+",
                    local:null-to-empty($originalFieldText),
                    local:endfield(local:combine(",",
                                        local:user-restriction(   $roleResponse/user:isUserInRolesResponse/role:RoleListReply/role:Principal/text()),
                                        local:group-restrictions($roleResponse/user:isUserInRolesResponse/role:RoleListReply/role:Role))))
}
&lt;/aci:fieldtext></con:xquery>
</con:xqueryEntry>