<?xml version="1.0" encoding="UTF-8"?>
<con:xqueryEntry xmlns:con="http://www.bea.com/wli/sb/resources/config">
  <con:xquery>declare namespace ns4 = "http://rep.oio.dk/skat.dk/TSE/betaling/xml/schemas/2006/09/01/";
declare namespace xf = "http://tempuri.org/XMLTransforms/Deliverance1/modtagMomsOutput/";
declare namespace ns0 = "http://rep.oio.dk/skat.dk/basis/kontekst/xml/schemas/2006/09/01/";
declare namespace ns1 = "http://rep.oio.dk/skat.dk/TSE/service/momsangivelsemodtag/xml/schemas/2006/09/01/";
declare namespace ns3 = "http://rep.oio.dk/skat.dk/TSE/angivelse/xml/schemas/2006/09/01/";
declare namespace ns2 = "http://skat.dk/begrebsmodel/2006/09/07/";
declare namespace ns5 = "http://rep.oio.dk/xkom.dk/xml/schemas/2006/09/01/";
declare namespace ns6 = "http://rep.oio.dk/skat.dk/TSE/virksomhed/xml/schemas/2006/09/01/";

declare function xf:modtagMomsOutput($modtagMomsAngivelse_O1 as element(ns2:ModtagMomsAngivelse_O))
    as element(ns1:MomsAngivelseOutputStruktur) {
        &lt;ns1:MomsAngivelseOutputStruktur>

            {
                for $Kvittering in $modtagMomsAngivelse_O1/ns2:Kvitteringsliste/ns2:Kvittering
                return
                    &lt;ns3:AngivelseKvitteringStruktur>
                        &lt;ns6:SEnummerIdentifikator>{ data($Kvittering/ns2:AngiverVirksomhedSENummer/ns2:VirksomhedSENummer) }&lt;/ns6:SEnummerIdentifikator>
                        &lt;ns3:AngivelsePeriodeStruktur>
                            &lt;ns5:StartDateTime>{ xs:dateTime( concat ( data($Kvittering/ns2:AngivelseValgtPeriode/ns2:AngivelseValgtPeriodeStartDato), 'T00:00:00.0Z' ) ) }&lt;/ns5:StartDateTime>
                            &lt;ns5:EndDateTime>{ xs:dateTime( concat ( data($Kvittering/ns2:AngivelseValgtPeriode/ns2:AngivelseValgtPeriodeSlutDato), 'T00:00:00.0Z' ) ) }&lt;/ns5:EndDateTime>
                        &lt;/ns3:AngivelsePeriodeStruktur>
                        &lt;ns3:AngivelseDatoTid>{ data($Kvittering/ns2:AngivelseAngivelseTid) }&lt;/ns3:AngivelseDatoTid>
                        {
                            for $AngivelseValuta in $Kvittering/ns2:AngivelseValuta
                            return
                                &lt;ns3:ValutaKode>{ data($AngivelseValuta) }&lt;/ns3:ValutaKode>
                        }
                        {
                        if(count($Kvittering/ns2:BetalingValgtBetalingFormidler)>0) then
                        &lt;ns4:BetalingsFormidlerKode>{ betalingsFormidler(data($Kvittering/ns2:BetalingValgtBetalingFormidler) ) }&lt;/ns4:BetalingsFormidlerKode>
                        else ""
                        }
                        {
                            for $BetalingDato in $Kvittering/ns2:BetalingDato
                            return
                                &lt;ns4:BetalingsDato>{ data($BetalingDato) }&lt;/ns4:BetalingsDato>
                        }
                        {
                            for $BetalingBeløb in $Kvittering/ns2:BetalingBeløb
                            return
                                &lt;ns4:BetalingsBeloeb>{ xs:decimal( data($BetalingBeløb) ) }&lt;/ns4:BetalingsBeloeb>
                        }
                        {
                            for $OCRLinie in $Kvittering/ns2:OCRLinie
                            return
                                &lt;ns3:OCRlinieStruktur>
                                    &lt;ns3:KortTypeIdentifikator>{ xs:string( padInFront(data($OCRLinie/ns2:AngivelseOCRKortType), 2, "0" ) ) }&lt;/ns3:KortTypeIdentifikator>
                                    &lt;ns3:OCRnummerIdentifikator>{ xs:string( padInFront(data($OCRLinie/ns2:AngivelseOCRNummer), 16, "0" ) ) }&lt;/ns3:OCRnummerIdentifikator>
                                    &lt;ns3:KontoNummerIdentifikator>{ padInFront(data($OCRLinie/ns2:AngivelseOCRKontoNummer), 8, "0" ) }&lt;/ns3:KontoNummerIdentifikator>
                                &lt;/ns3:OCRlinieStruktur>
                        }
                        &lt;ns3:AngivelseKvitteringIdentifikator>{ data($Kvittering/ns2:AngivelseKvitteringNummer) }&lt;/ns3:AngivelseKvitteringIdentifikator>
                    &lt;/ns3:AngivelseKvitteringStruktur>
            }
        &lt;/ns1:MomsAngivelseOutputStruktur>
};

declare function betalingsFormidler($betformidler) as xs:string{

		if ($betformidler = "SKB") then "JyskeBank"
		else if($betformidler = "AndenBetalingsform") then "Anden betalingsform"
		else if($betformidler = "JyskeBank") then "SKB"
		else if($betformidler = "Anden betalingsform") then "AndenBetalingsform"
		else $betformidler
};

declare function padInFront($value as xs:string, $requiredLength as xs:integer, $character as xs:string){

	if(string-length($value) &lt; $requiredLength) then padInFront(concat($character, $value), $requiredLength, $character)
	else $value
};

declare variable $modtagMomsAngivelse_O1 as element(ns2:ModtagMomsAngivelse_O) external;

xf:modtagMomsOutput($modtagMomsAngivelse_O1)</con:xquery>
</con:xqueryEntry>