<?xml version="1.0" encoding="UTF-8"?>
<con:xqueryEntry xmlns:con="http://www.bea.com/wli/sb/resources/config">
  <con:xquery>declare namespace xf = "http://tempuri.org/XMLTransforms/MomsAngivelseSystemIntegration_Tactical_2_SKAT_Output/";
declare namespace ns0 = "http://toldskat.dk/xml/schemas/raplet/2005/01/01/";
declare namespace ns1 = "http://skat.dk/begrebsmodel/2006/09/07/";

declare function betalingsFormidler($betformidler) as xs:string{

		if ($betformidler = "SKB") then "JyskeBank"
		else if($betformidler = "AndenBetalingsform") then "Anden betalingsform"
		else if($betformidler = "JyskeBank") then "SKB"
		else if($betformidler = "Anden betalingsform") then "AndenBetalingsform"
		else $betformidler
};
declare function padInFront($value as xs:string, $requiredLength as xs:integer, $character as xs:string){
	
	if(string-length($value) &lt; $requiredLength) then padInFront(concat($character, $value), $requiredLength, $character)
	else $value

};

declare function xf:MomsAngivelseSystemIntegration_Tactical_2_SKAT_Output($momsAngivelseSystemintegrationSvar as element(ns0:MomsAngivelseSystemintegrationSvar))
    as element(ns1:MomsAngivelseSystemIntegration_O) {
        let $MomsAngivelseSystemintegrationSvar := $momsAngivelseSystemintegrationSvar
        return
            &lt;ns1:MomsAngivelseSystemIntegration_O>
                {
                    let $Kontekst := $MomsAngivelseSystemintegrationSvar/ns0:Kontekst
                    return
                        &lt;ns1:Kontekst>
                            { $Kontekst/* }
                        &lt;/ns1:Kontekst>
                }
                &lt;ns1:Kvitteringsliste>
                    {
                        for $MomsAngivelseSystemintegrationSvarOplysninger in $MomsAngivelseSystemintegrationSvar/ns0:MomsAngivelseSystemintegrationSvarOplysninger
                        return
                            &lt;ns1:Kvittering>
                                &lt;ns1:AngiverVirksomhedSENummer>
                                    &lt;ns1:VirksomhedSENummer>{ data($MomsAngivelseSystemintegrationSvarOplysninger/ns0:SENummerAngiver) }&lt;/ns1:VirksomhedSENummer>
                                &lt;/ns1:AngiverVirksomhedSENummer>
                                {
                                    let $AngivelserValgtPeriode := $MomsAngivelseSystemintegrationSvarOplysninger/ns0:AngivelserValgtPeriode
                                    return
                                        &lt;ns1:AngivelseValgtPeriode>
                                            {
                                                for $StartDato in $AngivelserValgtPeriode/ns0:StartDato
                                                return
                                                    &lt;ns1:AngivelseValgtPeriodeStartDato>{ data($StartDato) }&lt;/ns1:AngivelseValgtPeriodeStartDato>
                                            }
                                            &lt;ns1:AngivelseValgtPeriodeSlutDato>{ data($AngivelserValgtPeriode/ns0:SlutDato) }&lt;/ns1:AngivelseValgtPeriodeSlutDato>
                                        &lt;/ns1:AngivelseValgtPeriode>
                                }
                                &lt;ns1:AngivelseKvitteringNummer>{ xs:integer( data($MomsAngivelseSystemintegrationSvarOplysninger/ns0:KvitteringsNummer) ) }&lt;/ns1:AngivelseKvitteringNummer>
                                {
                                    for $OCRLinie in $MomsAngivelseSystemintegrationSvarOplysninger/ns0:OCRLinie
                                    return
                                        &lt;ns1:OCRLinie>
                                            &lt;ns1:AngivelseOCRKortType>{ xs:integer( padInFront(data($OCRLinie/ns0:KortType), 2, "0") ) }&lt;/ns1:AngivelseOCRKortType>
                                            &lt;ns1:AngivelseOCRNummer>{ xs:integer( padInFront(data($OCRLinie/ns0:OCRNummer), 16, "0") ) }&lt;/ns1:AngivelseOCRNummer>
                                            &lt;ns1:AngivelseOCRKontoNummer>{ data($OCRLinie/ns0:KontoNummer) }&lt;/ns1:AngivelseOCRKontoNummer>
                                        &lt;/ns1:OCRLinie>
                                }
                                &lt;ns1:AngivelseAngivelseTid>{ data($MomsAngivelseSystemintegrationSvarOplysninger/ns0:AngivelsesTidspunkt) }&lt;/ns1:AngivelseAngivelseTid>
                                {
                                    for $ValutaKode in $MomsAngivelseSystemintegrationSvarOplysninger/ns0:ValutaKode
                                    return
                                        &lt;ns1:AngivelseValuta>{ data($ValutaKode) }&lt;/ns1:AngivelseValuta>
                                }
                                {if(count($MomsAngivelseSystemintegrationSvarOplysninger/ns0:ValgtBetalingsFormidler)>0) then
                                &lt;ns1:BetalingValgtBetalingFormidler>{ betalingsFormidler(data($MomsAngivelseSystemintegrationSvarOplysninger/ns0:ValgtBetalingsFormidler) ) }&lt;/ns1:BetalingValgtBetalingFormidler>
                                else ""
                                }
                                {
                                    for $BetalingsDato in $MomsAngivelseSystemintegrationSvarOplysninger/ns0:BetalingsDato
                                    return
                                        &lt;ns1:BetalingDato>{ data($BetalingsDato) }&lt;/ns1:BetalingDato>
                                }
                                {
                                    for $BetalingsBeloeb in $MomsAngivelseSystemintegrationSvarOplysninger/ns0:BetalingsBeloeb
                                    return
                                        &lt;ns1:BetalingBeløb>{ xs:integer( round(data($BetalingsBeloeb)) ) }&lt;/ns1:BetalingBeløb>
                                }
                            &lt;/ns1:Kvittering>
                    }
                &lt;/ns1:Kvitteringsliste>
            &lt;/ns1:MomsAngivelseSystemIntegration_O>
};

declare variable $momsAngivelseSystemintegrationSvar as element(ns0:MomsAngivelseSystemintegrationSvar) external;

xf:MomsAngivelseSystemIntegration_Tactical_2_SKAT_Output($momsAngivelseSystemintegrationSvar)</con:xquery>
</con:xqueryEntry>