<?xml version="1.0" encoding="UTF-8"?>
<con:xqueryEntry xmlns:con="http://www.bea.com/wli/sb/resources/config">
  <con:xquery>declare namespace xf = "http://tempuri.org/XMLTransforms/2BCMappings/VirksomhedSoeg_SKAT_2_TACTICAL_Input/";
declare namespace ns0 = "http://toldskat.dk/xml/schemas/raplet/2005/01/01/";
declare namespace ns1 = "http://skat.dk/begrebsmodel/2006/09/07/";

declare function padInFront($value as xs:string, $requiredLength as xs:integer, $character as xs:string){

	if(string-length($value) &lt; $requiredLength) then padInFront(concat($character, $value), $requiredLength, $character)
	else $value
};

declare function xf:VirksomhedSoeg_SKAT_2_TACTICAL_Input($virksomhedSøg_I1 as element(ns1:VirksomhedSøg_I))
    as element(ns0:VirksomhedSoeg) {
        &lt;ns0:VirksomhedSoeg>
            {
                let $Kontekst := $virksomhedSøg_I1/ns1:Kontekst
                return
                    &lt;ns0:Kontekst>
                        { $Kontekst/* }
                    &lt;/ns0:Kontekst>
            }
            {
	            let $VirksomhedCVRNummer := $virksomhedSøg_I1/ns1:Søgekriterier/ns1:VirksomhedCVRNummer
	            return if(count($VirksomhedCVRNummer) > 0) then
		            &lt;ns0:CVRNummer>{ xs:string(data($virksomhedSøg_I1/ns1:Søgekriterier/ns1:VirksomhedCVRNummer)) }&lt;/ns0:CVRNummer>
		        	else ""
	        }
	        {
	        	let $VirksomhedOplysningerInd := $virksomhedSøg_I1/ns1:Søgekriterier/ns1:VirksomhedOplysningerInd
	        	return if(count($VirksomhedOplysningerInd) > 0) then
	        	
		        	&lt;ns0:VirksomhedsSoegOplysninger>
	                {
	                    for $VirksomhedNavnFirmaNavnKort in $virksomhedSøg_I1/ns1:Søgekriterier/ns1:VirksomhedOplysningerInd/ns1:VirksomhedNavnFirmaNavnKort
	                    return
	                        &lt;ns0:FirmaNavnKort>{ data($VirksomhedNavnFirmaNavnKort) }&lt;/ns0:FirmaNavnKort>
	                }
	                {
	                    for $VirksomhedAdresseVejNavn in $virksomhedSøg_I1/ns1:Søgekriterier/ns1:VirksomhedOplysningerInd/ns1:VirksomhedAdresseVejNavn
	                    return
	                        &lt;ns0:VejNavn>{ data($VirksomhedAdresseVejNavn) }&lt;/ns0:VejNavn>
	                }
	                {
	                    for $VirksomhedAdresseFraHusNummer in $virksomhedSøg_I1/ns1:Søgekriterier/ns1:VirksomhedOplysningerInd/ns1:VirksomhedAdresseFraHusNummer
	                    return
	                        &lt;ns0:FraHusNummer>{(padInFront(data($VirksomhedAdresseFraHusNummer),3,'0' )) }&lt;/ns0:FraHusNummer>
	                }
	                {
	                    for $VirksomhedAdressePostNummer in $virksomhedSøg_I1/ns1:Søgekriterier/ns1:VirksomhedOplysningerInd/ns1:VirksomhedAdressePostNummer
	                    return
	                        &lt;ns0:PostNummer>{ xs:string( data($VirksomhedAdressePostNummer) ) }&lt;/ns0:PostNummer>
	                }
	                {
	                    for $VirksomhedAdressePostdistriktNavn in $virksomhedSøg_I1/ns1:Søgekriterier/ns1:VirksomhedOplysningerInd/ns1:VirksomhedAdressePostdistriktNavn
	                    return
	                        &lt;ns0:PostDistriktNavn>{ data($VirksomhedAdressePostdistriktNavn) }&lt;/ns0:PostDistriktNavn>
	                }
	            &lt;/ns0:VirksomhedsSoegOplysninger>
	           else ""
	        	
	        }
            
        &lt;/ns0:VirksomhedSoeg>
};

declare variable $virksomhedSøg_I1 as element(ns1:VirksomhedSøg_I) external;

xf:VirksomhedSoeg_SKAT_2_TACTICAL_Input($virksomhedSøg_I1)</con:xquery>
</con:xqueryEntry>